# POC - WordPress File Upload plugin, in the wfu_file_downloader.php file before version &lt;= 4.24.11 - (CVE-2024-9047)

[![My Shop](https://img.shields.io/badge/My%20Shop-verylazytech-%23FFDD00?style=flat&logo=buy-me-a-coffee&logoColor=yellow)](https://buymeacoffee.com/verylazytech/extras)
[![Medium](https://img.shields.io/badge/Medium-%40verylazytech-%231572B6?style=flat&logo=medium&logoColor=white)](https://medium.com/@verylazytech)
[![Github](https://img.shields.io/badge/Github-verylazytech-%23181717?style=flat&logo=github&logoColor=white)](https://github.com/verylazytech)
[![Buy Me A Coffee](https://img.shields.io/badge/Buy%20Me%20A%20Coffee-verylazytech-%23FFDD00?style=flat&logo=buy-me-a-coffee&logoColor=yellow)](https://buymeacoffee.com/verylazytech)
[![X](https://img.shields.io/twitter/url?url=https%3A%2F%2Fx.com%2Fverylazytech)](https://x.com/verylazytech)

## Overview

The WordPress File Upload plugin is vulnerable due to improper input validation in the wfu_file_downloader.php file, affecting versions <= 4.24.11. This vulnerability allows unauthenticated users to download arbitrary files from the server's filesystem, leading to potential data exfiltration and system compromise.

# Affected Devices

Websites running WordPress with the File Upload Plugin version <= 4.24.11.

# Affected Components

The vulnerability resides in the wfu_file_downloader.php component of the File Upload Plugin, which mishandles the file and handler parameters in its requests. This allows directory traversal attacks to access sensitive files.

**Read about it** — [CVE-2024-9047](https://nvd.nist.gov/vuln/detail/CVE-2024-9047)

> **Disclaimer**: This Proof of Concept (POC) is made for educational and ethical testing purposes only. Usage of this tool for attacking targets without prior mutual consent is illegal. It is the end user’s responsibility to obey all applicable local, state, and federal laws. Developers assume no liability and are not responsible for any misuse or damage caused by this program.

## Getting Started

### Finding Targets

To identify potential targets, you can use Fofa (a search engine similar to Shodan.io) with the following query:

- **Fofa Dork**: `body="wp-content/plugins/wp-file-upload" && body="wordpress-file-upload-style-css"`

![Fofa-cve-2024-9047](https://github.com/user-attachments/assets/a8952bba-e8e7-42ae-bd09-11d8914b6246)

### Cloning the Repository

First, clone the repository:

```bash
git clone https://github.com/verylazytech/CVE-2024-9047
cd CVE-2024-9047
chmod +x cve-2024-9047
```

Run the Exploit:

### For Linux / MacOs:
```bash
bash ./cve-2024-9047.sh <url> <file>
```
- Replace <url> with the target's URL (e.g., www.example.com).
- Replace <file> with the desired file path on the target server (e.g., /etc/passwd).

### Example Usage
```bash
./cve-2024-9047.sh www.vulnerablewebsite.com /etc/passwd
```

- The script will check the plugin version and, if vulnerable, attempt to retrieve the specified file.

![cve-2024-9047](https://github.com/user-attachments/assets/58b305c0-72c6-43e6-9f53-a03286d67556)
